﻿Imports Telerik.WinControls.UI
Imports System.IO

Partial Public Class Form1
    Inherits Form
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub radButton2_Click(sender As Object, e As EventArgs) Handles RadButton2.Click

        Dim list As New List(Of TilePosition)()
        For Each item As RadTileElement In RadPanorama1.Items
            list.Add(New TilePosition(item.Row, item.Column, item.Name))
        Next

        Dim s As System.Xml.Serialization.XmlSerializer = Nothing
        Using fs As New FileStream("C:\test.xml", FileMode.Create, FileAccess.Write, FileShare.Write)
            Using w As New System.Xml.XmlTextWriter(fs, System.Text.Encoding.[Default])
                s = New System.Xml.Serialization.XmlSerializer(GetType(List(Of TilePosition)))
                w.Formatting = System.Xml.Formatting.Indented
                s.Serialize(w, list)
            End Using
        End Using
    End Sub

    Private Sub radButton1_Click(sender As Object, e As EventArgs) Handles RadButton1.Click
        Dim list As New List(Of TilePosition)()
        Dim s As System.Xml.Serialization.XmlSerializer = Nothing
        Using fs As New FileStream("C:\test.xml", FileMode.Open, FileAccess.Read)
            Using w As New System.Xml.XmlTextReader(fs)
                s = New System.Xml.Serialization.XmlSerializer(GetType(List(Of TilePosition)))

                list = DirectCast(s.Deserialize(w), List(Of TilePosition))
            End Using
        End Using

        If list IsNot Nothing Then
            For Each item As TilePosition In list
                DirectCast(RadPanorama1.Items(item.TileName), RadTileElement).Row = item.Row
                DirectCast(RadPanorama1.Items(item.TileName), RadTileElement).Column = item.Column
            Next
        End If
        RadPanorama1.PanoramaElement.InvalidateArrange()
    End Sub
End Class

<Serializable> _
Public Class TilePosition
    Public Property Row() As Integer
        Get
            Return m_Row
        End Get
        Set(value As Integer)
            m_Row = value
        End Set
    End Property
    Private m_Row As Integer

    Public Property Column() As Integer
        Get
            Return m_Column
        End Get
        Set(value As Integer)
            m_Column = value
        End Set
    End Property
    Private m_Column As Integer

    Public Property TileName() As String
        Get
            Return m_TileName
        End Get
        Set(value As String)
            m_TileName = value
        End Set
    End Property
    Private m_TileName As String

    Public Sub New()
    End Sub

    Public Sub New(row As Integer, column As Integer, tileName As String)
        Me.Row = row
        Me.Column = column
        Me.TileName = tileName
    End Sub
End Class
